.nolist
include \masm32\include\masm32rt.inc
.686
.xmm
include \masm32\macros\timers.asm
include \masm32\macros\fcinvoke.asm

; Usage:

FcDemo3Regs	PROTO		; the procedure has 3 arguments, all three are passed through registers
; fcinv FcDemo3Regs, ecx:82, edx:offset MainString, eax:offset SubString

FcDemo2Regs	PROTO: DWORD	; the procedure has 3 arguments, only one is passed on the stack
; fcinv FcDemo2Regs, ecx:82, edx:offset MainString, offset SubString

; same for obtaining timings in a standardised format:
; showcycles FcDemo2Regs, ecx:82, edx:offset MainString, offset SubString

.code
SourceString	db "This is a long string meant for testing the Masm32 lib InString algo, and we want to find the word 'end'", 0
SubString	db "end", 0

start:
	if 0	; put 1 to test the help feature
		fcinv ?			; get help on
		showcycles ?		; these macros
	else

	call TestAddr			; a demo with a local string

	print "The InString results are "
	fcinv FcDemo2Regs, ecx:99, edx:addr SourceString, addr SubString
	print str$(eax), "/"
	fcinv FcDemo3Regs, ecx:50, edx:offset SourceString, eax:offset SubString
	print str$(eax), "/"
	fcinv FcDemo2Regs, ecx:1, edx:chr$("Does this string have an end?"), offset SubString
	print str$(eax), 13, 10, 10

	showcycles FcDemo3Regs, ecx:99, edx:offset SourceString, eax:addr SubString
	showcycles FcDemo2Regs, ecx:50, edx:addr SourceString, offset SubString
	showcycles FcDemo2Regs, ecx:01, edx:addr SourceString, addr SubString
	showcycles FcDemo2Regs, ecx:25, edx:chr$("Does this string have an end?"), offset SubString

	invoke Sleep, 50
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS				; --------- the traditional way ---------
		invoke InString, 1, addr SourceString, addr SubString
	counter_end
	print str$(eax), 9, "InString, 1, addr SourceString, addr SubString", 13, 10	; --------- end traditional way ---------

	and globcycles, 0	; reset the average cycles
	and globcount, 0	; and the counter

	REP_CT = 5							; optional: perform the showcycles for five lines, to see the variance
	showcycles InString, 1, addr SourceString, addr SubString		; --------- with the timings macro: one line ---------

	print chr$("Average cycle count for last 5:" , 9)
	mov eax, globcycles
	cdq
	div globcount
	print str$(eax), 13, 10, 10	
	endif
	inkey "--- ok ---"
	exit

TestAddr proc
LOCAL LocBuffer [260]:BYTE
  invoke GetModuleFileName, 0, addr LocBuffer, 260	; eax returns # of bytes copied not incl. null
  print "Test local string "
  print addr LocBuffer, ", instr '.exe' = "
  fcinv FcDemo3Regs, ecx:1, edx:addr LocBuffer, eax:chr$(".exe")
  print str$(eax), 13, 10, 10
  ret
TestAddr endp

FcDemo2Regs proc arg3:DWORD
	invoke InString, ecx, edx, arg3
	ret
FcDemo2Regs endp

FcDemo3Regs proc
	invoke InString, ecx, edx, eax
	ret
FcDemo3Regs endp

end start

RichMasm options:
OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0
